{$X+}

unit UTxtRead;

interface

uses Dialogs,Classes,UCBaza;

const
  MaxSize = $7FFF; { Size of the record buffer }

type
  TBigArray = array[0..65000] of char;
  PBigArray = ^TBigArray;

  TBazaTxt1 = class(TCustomBaza)
  private
    FfileName : string;    { Name of the DB file }
    fileOpen  : boolean;   { TRUE if the file is open }
    DBfile    : TextFile;  { The actual file }
    buffer    : PBigArray; { Temp buffer for record }
    {procedure readln(var plik:textfile; wynik:pchar);}
    procedure SetFileName(name : string); override;
  protected
  public
    constructor Create;
    destructor Destroy; override;

    procedure Close; override;
    function Open:boolean; override;
    procedure Seek(r : longint); override;
    procedure GotoStart; override;
    procedure GotoNext; override;
  public
    property FileName : string read FfileName write SetFileName;
  end;

implementation
uses SysUtils;

{var
  temp : TBigArray;}

constructor TBazaTxt1.Create;
begin
  inherited Create;
  fileOpen:=FALSE;
  fileName:='';
  buffer:=nil;
  fields:=tStringList.Create;
  fields.sorted:=false;
  rec:=tStringList.Create;
  rec.sorted:=false;
end;

destructor TBazaTxt1.destroy;
begin

  fields.Clear;


  inherited destroy;
end;

procedure TBazaTxt1.SetFileName(name : string);
begin
  if fileOpen and (FfileName<>name) then
    close;

  FfileName:=name;
end;

function TBazaTxt1.open;
const
  wlkTemp = 32000;
var
  done : boolean;
  pfm: byte;
  pom: PBigArray;
  wsk,temp2:pointer;
  pom_l:longint;
  temp: PBigArray;

  procedure Kom1;
  begin
    MessageDlg('Bd w bazie danych lub baza nie ma struktury DBASE 3 PLUS',mtError,[mbCancel],0);
  end;

begin
  if FileOpen then
    close; { Close the file if it already open }

  done:=FALSE;

  New(temp);
  New(pom);
  Result:=false;
  buffer:=nil;
  try
    if fFileName<>'' then
    begin
      try
        assignFile(DBfile,FfileName);
        pfm:=fileMode;
        fileMode:=0;
        {$I-} reset(DBfile); {$I+}
        fileMode:=pfm;

        if ioResult=0 then
        begin
          try
            ReadLn(DBFile,temp^);
            temp2:=temp;
            repeat
              if (temp2<>nil) and (temp^[0]<>#0) then
              begin
                wsk:=StrScan(temp2,#9);
                pom_l:=longint(wsk)-longint(temp2);
                if wsk = nil then StrCopy(pom^,temp2) else
                StrLCopy(pom^,temp2,pom_l);
                temp2:=wsk;
                if wsk<>nil then Inc(LongInt(temp2));
                fields.add(strPas(pom^));
             end
             else
               done:=TRUE;
            until DONE;

            FileOpen:=TRUE;
            cRecord:=0;
            seek(0);
            Result:=true;
           except
            Close;
            Kom1;
          end;
        end;
      except
        Kom1;
      end;
    end;
  finally
    Dispose(pom);
    Dispose(temp);
  end;
end;

procedure TBazaTxt1.close;
begin
  if fileOpen then
  begin
    FileOpen:=FALSE;
    closeFile(DBfile);
    buffer:=nil;
    fields.Clear;
  end;
end;


procedure TBazaTxt1.seek(r : longint);
const
  wlkTemp = 32000;
var
  temp: PBigArray;
  done : boolean;
  pom: PBigArray;
  wsk,temp2:pointer;
  czytnik:string;
  licznik: longint;
  pom_l:longint;
begin
  rec.clear;
  New(temp);
  New(pom);
  try
    if FileOpen then
    begin
      if cRecord>=r then {licznik:=cRecord else}
      begin
        CloseFile(Dbfile);
        Reset(Dbfile);
        cRecord:=-1;
        licznik:=-1;
      end;
      licznik:=-1;
      while (cRecord<r) and (licznik<r) do
      begin
         ReadLn(DBfile,czytnik);
         cRecord:=cRecord+1;
         if eof(dbfile) then
         begin
           licznik:=r+1;
           cRecord:=r;
         end;
      end;
      temp2:=temp;
      done:=false;
  {    if licznik=r then}
      BazaEOF:= (ioResult<>0) or Eof(DbFile);

      {$I-}

      Read(DBFile,temp^);
      {$I+}


      rec.Clear;
      repeat
        if (temp2<>nil) and (temp^[0]<>#0) then
          begin
            wsk:=StrScan(temp2,#9);
            pom_l:=longint(wsk)-longint(temp2);
            if wsk = nil then StrCopy(pom^,temp2) else
            StrLCopy(pom^,temp2,pom_l);
            temp2:=wsk;
            if wsk<>nil then Inc(LongInt(temp2));
            czytnik:=StrPas(pom^);
            rec.add(czytnik);
          end
        else
            done:=TRUE;
      until DONE;
    end;
  finally
    Dispose(temp);
    Dispose(pom);
  end;
end;

procedure TBazaTxt1.GotoStart;
begin
  seek(0);
end;

procedure TBazaTxt1.GotoNext;
begin
  seek(cRecord+1);
end;

end.
