unit Ucbaza;

interface
uses Classes,SysUtils;

type
  TCustomBaza = class(TObject)
  private

  protected
    FFileName: String;
    cRecord: Longint;
    procedure SetFileName(name : string); virtual; abstract;
    function GetWart(nazwaPola:openString):string; virtual;
  public
    fields    : tStringList;      { The field data }
    rec       : tStringList; { Record data }
    bazaEOF: boolean;
    destructor Destroy; override;
    procedure Close; virtual; abstract;
    function Open:boolean; virtual; abstract;
    procedure write(r : longint); virtual; abstract;
    procedure Seek(r : longint); virtual; abstract;
    procedure NewRecord; virtual; abstract;
    procedure GotoStart; virtual; abstract;
    procedure GotoEnd; virtual; abstract;
    procedure GotoNext; virtual; abstract;
  public
    property FileName : string read FfileName write SetFileName;
    property numerRekordu:longint read cRecord;
    property wart[nazwaPola:openString]:string read GetWart;
    function CzyJestPole(nazwaPola:openString):boolean; virtual;
  end;

implementation

function TCustomBaza.GetWart;
var
  i: integer;
  p: byte;
begin
  Result:='';
  i:=fields.IndexOf(UpperCase(nazwaPola));
  if (i>=0) and (i<rec.Count) then
  begin
    Result:=rec.strings[i];
    {p:=Pos(#255#254,Result);
    While p>0 do
    begin
      Result[p]:=#13;
      Result[p+1]:=#10;
      p:=Pos(#255#254,Result);
    end;}
  end;
end;

function TCustomBaza.CzyJestPole;
begin
  Result:=fields.IndexOf(UpperCase(nazwaPola))>=0;
end;

destructor TCustomBaza.Destroy;
begin
  Close;

  fields.Free;
  rec.Free;

  inherited Destroy;
end;

end.
