unit Udefwydr;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Grids, UPowiaz, Dialogs, ExtCtrls;

type
  Tform_defWydr = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    grid: TStringGrid;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    CheckBox1: TCheckBox;
    RadioGroup1: TRadioGroup;
    edit_symbolformul: TEdit;
    OpenDialog1: TOpenDialog;
    fileNameEdit1: TEdit;
    SpeedButton1: TSpeedButton;
    Label5: TLabel;
    spis_typPliku: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure spis_typPlikuClick(Sender: TObject);
  private
    { Private declarations }
    powiaz: tPowiazania;
    procedure WypelnijGrid;
    procedure Zapisz;
  public
    { Public declarations }
    property powiazanie:tPowiazania read powiaz write powiaz;
  end;

var
  form_defWydr: Tform_defWydr;

implementation
uses IniFilEx;

{$R *.DFM}

procedure Tform_defWydr.FormShow(Sender: TObject);
begin
  grid.rowCount:=maxPolFormul;
  grid.cells[0,0]:='pola formul.';
  grid.cells[1,0]:='pola bazy';

  spis_typPliku.ItemIndex:=powiaz.typBazy;
  WypelnijGrid;
end;

procedure Tform_defWydr.OKBtnClick(Sender: TObject);
begin
  if edit1.text='' then
  begin
    MessageDlg('Brak nazwy wydruku',mtWarning,[mbCancel],0);
    ModalResult:=mrNone;
    Exit;
  end;
  powiaz.typBazy:=spis_typPliku.ItemIndex;
  Zapisz;
end;

procedure Tform_defWydr.WypelnijGrid;
var
  f,rowGrid: integer;
begin
  grid.RowCount:=2;
  grid.cells[0,1]:='';
  grid.cells[1,1]:='';
  grid.RowCount:=MaxPolFormul;

  edit1.text:=powiaz.nazwa;
  edit_symbolFormul.text:=powiaz.symbol;
  FileNameEdit1.text:=powiaz.nBazy;
  edit2.text:=powiaz.nPola1;
  edit3.text:=powiaz.nPola2;
  edit4.text:=powiaz.nPola3;
  checkBox1.checked:=powiaz.przeliczaj;
  try
  radioGroup1.itemIndex:=powiaz.kodyZn-1;
  except
  end;

  rowGrid:=1;
  for f:=0 to powiaz.listaPol.count-1 do
  begin
    grid.cells[0,rowGrid]:=DajKlucz(powiaz.listaPol.strings[f]);
    grid.cells[1,rowGrid]:=DajValue(powiaz.listaPol.strings[f]);
    Inc(rowGrid);
  end;
end;

procedure tform_defWydr.Zapisz;
var
  f: integer;
begin
  powiaz.Zeruj;
  powiaz.nazwa:=edit1.text;
  powiaz.symbol:=edit_symbolFormul.text;
  powiaz.nBazy:=FileNameEdit1.text;
  powiaz.nPola1:=edit2.text;
  powiaz.nPola2:=edit3.text;
  powiaz.nPola3:=edit4.text;
  powiaz.przeliczaj:=checkBox1.checked;
  powiaz.kodyZn:=radioGroup1.itemIndex+1;
  for f:=1 to grid.RowCount-1 do
  begin
    if grid.cells[0,f]<>'' then
      powiaz.Dopisz(grid.cells[0,f],grid.cells[1,f]);
  end;
  powiaz.Zapisz;
end;

procedure Tform_defWydr.SpeedButton1Click(Sender: TObject);
begin
  OpenDialog1.fileName:=fileNameEdit1.text;
  if OpenDialog1.Execute then
    fileNameEdit1.text:=OpenDialog1.fileName;
end;

procedure Tform_defWydr.spis_typPlikuClick(Sender: TObject);
begin
  powiaz.typBazy:=spis_typPliku.ItemIndex;
  Case powiaz.typBazy of
    0: begin
         OpenDialog1.DefaultExt:='DBF';
         OpenDialog1.Filter:='*.dbf|*.dbf';
       end;
    1: begin
         OpenDialog1.DefaultExt:='TXT';
         OpenDialog1.Filter:='*.txt|*.txt|wszystkie|*.*';
       end;
  end;

  
end;

end.
