unit Inifilex;

interface
uses Classes,IniFiles;

type
  tIniFileEx = class(tIniFile)
    {$IFNDEF WIN32}
    procedure ReadSections(lista:tStrings);
    {$ENDIF}
  end;
const
  maxPolFormul = 999;
  code: integer = 0;

function DajNPlIni:string;
function DajValue(tx:String):string;
function DajKlucz(tx:String):string;
function LoadZero(tx:String; ile:word):string;
function StrToNum(s:String):longint;

implementation
uses Forms,SysUtils;


{$IFNDEF WIN32}
procedure tIniFileEx.ReadSections;
var
  plTx: textFile;
  tx: string;
begin
  if lista<>nil then
  begin
    AssignFile(plTx,FileName);
    {$I-} Reset(plTx); {$I+}
    if ioResult=0 then
    begin
      While not Eof(plTx) do
      begin
        ReadLn(plTx,tx);
        if (Copy(tx,1,1)='[') and (Copy(tx,length(tx),1)=']') then
          lista.Add(Copy(tx,2,length(tx)-2));
      end;
      CloseFile(plTx);
    end;
  end;
end;
{$ENDIF}


function DajNPlIni;
begin
  Result:=ExtractFilePath(Application.ExeName)+'wydrform.ini';
end;

function DajValue(tx:String):string;
var
  p: word;
begin
  p:=Pos('=',tx);
  if p>0 then
    Result:=Copy(tx,p+1,length(tx))
  else
    Result:='';
end;
function DajKlucz(tx:String):string;
var
  p: word;
begin
  p:=Pos('=',tx);
  if p>0 then
    DajKlucz:=Copy(tx,1,p-1)
  else
    DajKlucz:=tx;
end;

function LoadZero;
var
  f: integer;
begin
  result:=tx;
  for f:=length(tx)+1 to ile do
    result:='0'+result;
end;

function StrToNum;
begin
  {While Copy(s,1,1)='0' do
    Delete(s,1,1);}
  Val(s,Result,code);
end;

end.
